var canvasContext = new Array();
var canvas = new Array();
var img = new Array();

function eyecatch( selector ) {
	if ( jQuery.browser.msie && parseInt( jQuery.browser.version ) <= 6 ) {
		return false;
	}
	var i = 0;
	jQuery( selector ).each( function() {
		var thisSrc = jQuery(this).attr('src');
		var doneSrc = PODSPOD_PME_BASE + "done/" + basename( thisSrc );
		var thisObj = this;
		jQuery.ajax({
			url : doneSrc,
			type : 'GET',
			statusCode : {
				200 : function() {
					thisObj.src = doneSrc;
				},
				404 : function() {
					img[i] = new Image();
					img[i].src = thisSrc;

					// canvas要素のノードオブジェクト
					//canvas = document.createElement('canvas');
					//img.appendChild(canvas);
					jQuery(thisObj).after(
						jQuery('<canvas></canvas>').attr( 'id', 'canvas_' + i )
					);
					jQuery('#canvas_' + i).attr( 'width', img[i].width );
					jQuery('#canvas_' + i).attr( 'height', img[i].height );
					jQuery('#canvas_' + i).attr( 'class', jQuery(thisObj).attr( 'class' ) );
			
					//canvas = document.getElementById('canvas');
					canvas[i] = jQuery( '#canvas_' + i ).get(0);
			
					// canvas要素の存在チェックとCanvas未対応ブラウザの対処
					if ( !canvas[i] || !canvas[i].getContext )
					{
						return false;
					}
			
					jQuery(thisObj).hide();
			
					// 2Dコンテキストの取得
					canvasContext[i] = canvas[i].getContext('2d');
			
        				canvasContext[i].setTransform(1,-0.5,0,1,0,0);
        				var rate = 1.5;
        				canvasContext[i].scale(rate, rate);
        				canvasContext[i].translate(-img[i].width/4, 0);
			
					// いったん描画
					canvasContext[i].drawImage(img[i], 0, 0);
			
					// キャンバスからImageDataを取得
					var input = canvasContext[i].getImageData(0, 0, canvas[i].width, canvas[i].height);
			
					// 変換！
					var output = gaussian(input, canvasContext[i]);
			
					// 変換した画像を出力
					canvasContext[i].putImageData(output, 0, 0);
					var dataUrl = canvas[i].toDataURL();
					jQuery.ajax({
						url : PODSPOD_PME_BASE + "done.php",
						type : 'POST',
						data : { doneSrc : doneSrc, dataUrl : dataUrl }
					});
					i++;
				}
			}
		});

	} );
}

/**
 * 乱数を取得します。
 */
var getRand = function(r) { return parseInt(Math.random()*r); }

/**
 * inputDataの画像をグレースケール加工します。
 * @param inputData 入力画像
 */
var grayscale = function(inputData, canvasContext)
{
	// データを入れる空のImageDataを作成
	var outputData = canvasContext.createImageData(inputData.width, inputData.height);

	// フィルタ処理
	for ( var y = 0; y < inputData.height; ++y )
	{
		for ( var x = 0; x < inputData.width; ++x )
		{
			var rgb = getPixel( inputData, x, y );
			// グレースケールの計算（重み付き平均をとる方法）
			// 出力画素 = (0.299 * R成分 + 0.587 * G成分 + 0.114 * B成分)
			// 参考：http://www.geocities.co.jp/Milkyway/4171/graphics/002-6.html
			var newcolor = (0.299 * rgb.R) + (0.587 * rgb.G) + (0.114 * rgb.B);
			setPixel(outputData, x, y, newcolor, newcolor, newcolor, 255);
		}
	}
	return outputData;
}

/**
 * inputDataの画像をガウスフィルタ加工します。
 * @param inputData 入力画像
 */
var gaussian = function(inputData, canvasContext)
{
	// データを入れる空のImageDataを作成
	var outputData = canvasContext.createImageData(inputData.width, inputData.height);

	var sigma = 1.0;
	var dot = 4;
	var div = 2 * Math.PI * ((sigma)*(sigma));

	var weight = new Array();
	for ( var i = -dot; i <= dot; i++ )
	{
		weight[i + dot] = new Array();
		for ( var j = -dot; j <= dot; j++ )
		{
			weight[i + dot][j + dot] = Math.exp(- ((j*j) + (i*i)) / (2 * ((sigma)*(sigma))) );
		}
	}

	// フィルタ処理
	// 参考：http://lovezawa.it-frogs.jp/programming/c/sift/sift↓
	//	   %E3%81%AE%E5%AE%9F%E8%A3%851-%E3%82%AC%E3%82%A6%E3%82%B9%E↓
	//	   3%83%95%E3%82%A3%E3%83%AB%E3%82%BF/
	var tmpR, tmpG, tmpB;
	for ( var y = 0; y < inputData.height; ++y )
	{
		for ( var x = 0; x < inputData.width; ++x )
		{
			if( y < (inputData.height*1/2) ) {
				tmpR = tmpG = tmpB = 0;
				for( var yy = -dot; yy <= dot; yy++ )
				{
					for( var xx = -dot; xx <= dot; xx++ )
					{
						var rgb = getPixel( inputData, x + xx, y + yy );
						var w = weight[yy + dot][xx + dot];
						if(typeof(rgb) == "undefined") continue;
						tmpR += rgb.R * w;
						tmpG += rgb.G * w;
						tmpB += rgb.B * w;
					}
				}
				setPixel(outputData, x, y, 
						Math.round(tmpR / div), Math.round(tmpG / div), Math.round(tmpB / div), 
						255);
			} else {
				var rgb = getPixel( inputData, x, y );
				setPixel(outputData, x, y, 
						rgb.R, rgb.G, rgb.B, 
						255);
			}
		}
	}
	return outputData;
}

function getPixel(imageData, x, y)
{
	var pixels = imageData.data;
	var index = (imageData.width * y * 4) + (x * 4);
	if(index < 0 || index + 3 > pixels.length) return undefined;
	return { R:pixels[index + 0], G:pixels[index + 1], B:pixels[index + 2], A:pixels[index + 3] };
}

function setPixel(imageData, x, y, r, g, b, a)
{
	var pixels = imageData.data;
	var index = (imageData.width * y * 4) + (x * 4);
	if(index < 0 || index + 3 > pixels.length) return false;
	pixels[index + 0] = r;
	pixels[index + 1] = g;
	pixels[index + 2] = b;
	pixels[index + 3] = a;
	return true;
}
function basename(path) {
	return path.replace(/\\/g,'/').replace( /.*\//, '' );
}

function dirname(path) {
	return path.replace(/\\/g,'/').replace(/\/[^\/]*$/, '');;
}

